from .version import __version__

__doc__ = (
    "GPTQ: Accurate Post-training Compression for Generative Pretrained Transformers."
)
__date__ = "2023-03-01"
__credits__ = "IST Austria Distributed Algorithms and Systems Lab"

from .gptq import GPTQ
from .quant import Quantizer, make_quant, QuantLinear, quantize
from .modelutils import find_layers
from .datautils import get_loaders
from .utils import avoid_tensor_modified
from quant_cuda import matvmul2, matvmul3, matvmul4, matvmul8
